// MediaViewer.cpp: CMediaViewer NX̃Cve[V
//
// 2008/09/01 @Meru
//   CBonSrcFilterIBaseFilterœo^悤ɕύX
//     ->Graphɒǉ̂IBaseFilterœꂵ̂ƁA
//       MediaViewer.cppAddRef()ꂽȂׁB
//   \z CDirectShowUtil g悤ɂǍʂǂB
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MediaViewer.h"
#include <Dvdmedia.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// ǉGUID
//////////////////////////////////////////////////////////////////////

// MPV Decorder Filter {39F498AF-1A09-4275-B193-673B0BA3D478}
#ifndef CLSID_MPV_DecorderFilter
DEFINE_GUID(CLSID_MPV_DecorderFilter,0x39F498AF, 0x1A09, 0x4275, 0xB1, 0x93, 0x67, 0x3B, 0x0B, 0xA3, 0xD4, 0x78);
#endif

// ffdshow Video Decorder {04FE9017-F873-410E-871E-AB91661A4EF7}
#ifndef CLSID_ffdshow_Video_Decorder
DEFINE_GUID(CLSID_ffdshow_Video_Decorder,0x04FE9017, 0xF873, 0x410E, 0x87, 0x1E, 0xAB, 0x91, 0x66, 0x1A, 0x4E, 0xF7);
#endif

// ATI MPEG Video Decorder {37A4D808-E76C-11D2-935C-00A024E52661}
#ifndef CLSID_ATI_MPEG_Video_Decoder
DEFINE_GUID(CLSID_ATI_MPEG_Video_Decoder,0x37a4d808, 0xe76c, 0x11d2, 0x93, 0x5c, 0x00, 0xa0, 0x24, 0xe5, 0x26, 0x61);
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMediaViewer::CMediaViewer(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1UL, 0UL)
	, m_bInit(false)

	, m_pFilterGraph(NULL)

	, m_pSrcFilter(NULL)
	, m_pBonSrcFilterClass(NULL)

	, m_pMpeg2SeqFilter(NULL)
	, m_pMpeg2SeqClass(NULL)

	, m_pAacDecFilter(NULL)	
	, m_pAacDecClass(NULL)
	
	, m_pPcmSelFilter(NULL)
	, m_pPcmSelClass(NULL)
	
	, m_pMp2DemuxFilter(NULL)
	, m_pMpeg2DecFilter(NULL)

	, m_pVideoRenderer(NULL)

	, m_strMpeg2DecorderName()

	, m_pMp2DemuxInterface(NULL)
	, m_pMp2DemuxRefClock(NULL)

	, m_pMp2DemuxVideoMap(NULL)
	, m_pMp2DemuxAudioMap(NULL)

	, m_pBasicAudio(NULL)
	
	, m_wVideoEsPID(0xFFFFU)
	, m_wAudioEsPID(0xFFFFU)
	
	, m_wVideoWindowX(0)
	, m_wVideoWindowY(0)
	, m_VideoInfo()
	, m_hOwnerWnd(NULL)
	, m_bFullscreen(false)
	, m_dwRegister(0)
	, m_iForceAspectRatioX(0)
	, m_iForceAspectRatioY(0)
	, m_eVideoDecoder(VideoDecoder_Auto)
	, m_eRendererType(CDirectShowUtil::Renderer_Unknown)
{
	// COMCu
	::CoInitialize(NULL);
}

CMediaViewer::~CMediaViewer()
{
	CloseViewer();

	// COMCuJ
	::CoUninitialize();
}

void CMediaViewer::Reset(void)
{
	Stop();

	CMediaDecoder::Reset();

	SetVideoPID(0xFFFFU);
	SetAudioPID(0xFFFFU);

	Play();
}

const bool CMediaViewer::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	CTsPacket *pTsPacket = dynamic_cast<CTsPacket *>(pMediaData);

	// ̓fBAf[^͌݊Ȃ
	if(!pTsPacket)return false;
	
	// tB^Otɓ
	if(m_pBonSrcFilterClass){
		return m_pBonSrcFilterClass->InputMedia(pTsPacket);
		}

	return false;
}

// iRendererMode = 7     : VMR7
// iRendererMode = 9     : VMR9
// iRendererMode = 10    : EVR
// iRendererMode = other : Default
const bool CMediaViewer::OpenViewer(HWND hOwnerHwnd,HWND hMessageDrainHwnd
									,CDirectShowUtil::RendererType eRendererType
									)
{	
	if(m_bInit)return false;

	bool bRet = true;
	HRESULT hReturn=S_OK;
	int refCount;

	CMediaType MediaTypeVideo;
	CMediaType MediaTypeAudio;	

	IPin *pOutput = NULL;
	IPin *pOutputVideo = NULL;
	IPin *pOutputAudio = NULL;
	IPin *pInput = NULL;

	try{
		CDirectShowUtil cDSUtil;
		wchar_t wszFilterName[128];

		// tB^Ot}l[W\z
		if(::CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, (void**)&m_pFilterGraph) != S_OK)
			throw CBonTsEngineException(L"tB^Ot}l[W[̍\zł܂B\n");
		AddToRot(m_pFilterGraph, &m_dwRegister);

		/* CBonSrcFilter */
		{
			// CX^X쐬
			m_pSrcFilter = CBonSrcFilter::CreateInstance(NULL, &hReturn,&m_pBonSrcFilterClass);
			if((!m_pSrcFilter) || (hReturn != S_OK))
				throw CBonTsEngineException(L"BonSrcFilter\zɎs܂B\n");
			refCount = CDirectShowUtil::GetRefCount(m_pSrcFilter);
			// tB^Otɒǉ
			if(m_pFilterGraph->AddFilter(m_pSrcFilter, L"BonSrcFilter") != S_OK)
				throw CBonTsEngineException(L"BonSrcFilter̃OtǉɎs܂B\n");
			refCount = CDirectShowUtil::GetRefCount(m_pSrcFilter);
			// o̓s擾
			pOutput = CDirectShowUtil::GetFilterPin(m_pSrcFilter,PINDIR_OUTPUT);
			if(!pOutput) throw CBonTsEngineException(L"BonSrcFiltero̓s̎擾Ɏs܂B\n");
			refCount = CDirectShowUtil::GetRefCount(m_pSrcFilter);			
		}

		// MPEG-2 Demultiplexer
		{
			// MPEG-2 DemultiplexerCX^X쐬āAڑs
			if(!CDirectShowUtil::AppendFilter_and_Connect(CLSID_MPEG2Demultiplexer,
				L"Mpeg2Demuxer", m_pFilterGraph, (IBaseFilter**)&m_pMp2DemuxFilter , &pOutput))
				throw CBonTsEngineException(L"Mpeg2Demultiplexer̍\zɎs܂B\n");
			// ̎_pOutput==NULL̂͂Ô
			SAFE_RELEASE(pOutput);			
			// IMpeg2DemultiplexerC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IMpeg2Demultiplexer, (void**)&m_pMp2DemuxInterface) != S_OK)
				throw CBonTsEngineException(L"Mpeg2Demultiplexer̃CX^X擾Ɏs܂B\n");
			// IReferenceClockC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IReferenceClock, (void**)&m_pMp2DemuxRefClock) != S_OK)
				throw CBonTsEngineException(L"t@XNbNC^[tF[X̍\zɎs܂B\n");
			// t@XNbNI
			if(m_pMp2DemuxFilter->SetSyncSource(m_pMp2DemuxRefClock) != S_OK)
				throw CBonTsEngineException(L"t@XNbN̑IɎs܂B\n");
			// ffBAtH[}bgݒ		
			MediaTypeVideo.InitMediaType();
			MediaTypeVideo.SetType(&MEDIATYPE_Video);
			MediaTypeVideo.SetSubtype(&MEDIASUBTYPE_MPEG2_VIDEO);
			MediaTypeVideo.SetVariableSize();
			MediaTypeVideo.SetTemporalCompression(TRUE);
			MediaTypeVideo.SetSampleSize(0);
			MediaTypeVideo.SetFormatType(&FORMAT_MPEG2Video);	
			 // tH[}bg\̊m
			MPEG2VIDEOINFO *pVideoInfo = (MPEG2VIDEOINFO *)MediaTypeVideo.AllocFormatBuffer(sizeof(MPEG2VIDEOINFO));
			if(!pVideoInfo) throw CBonTsEngineException(L"tH[}bg\̃mۂɎs܂B\n");
			::ZeroMemory(pVideoInfo, sizeof(MPEG2VIDEOINFO));
			// rfIwb_ݒ
			VIDEOINFOHEADER2 &VideoHeader = pVideoInfo->hdr;
			::SetRect(&VideoHeader.rcSource, 0, 0, 720, 480);
			VideoHeader.bmiHeader.biHeight = 480;
			VideoHeader.bmiHeader.biWidth = 720;
			// fo̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeVideo, L"Video", &pOutputVideo) != S_OK)
				throw CBonTsEngineException(L"rfIo̓s̍쐬Ɏs܂B\n");
			// fBAtH[}bgݒ	
			MediaTypeAudio.InitMediaType();
			MediaTypeAudio.SetType(&MEDIATYPE_Audio);
			MediaTypeAudio.SetSubtype(&MEDIASUBTYPE_NULL);
			MediaTypeAudio.SetVariableSize();
			MediaTypeAudio.SetTemporalCompression(TRUE);
			MediaTypeAudio.SetSampleSize(0);
			MediaTypeAudio.SetFormatType(&FORMAT_None);
			// o̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeAudio, L"Audio", &pOutputAudio) != S_OK)
				throw CBonTsEngineException(L"I[fBIo̓s̏o͂Ɏs܂B\n");
			// fo̓sIMPEG2PIDMapC^tF[X̃NG[
			if(pOutputVideo->QueryInterface(IID_IMPEG2PIDMap, (void**)&m_pMp2DemuxVideoMap) != S_OK)
				throw CBonTsEngineException(L"rfIo̓sPID}bv̎擾Ɏs܂B\n");
			// o̓sIMPEG2PIDMapC^tF[X̃NG
			if(pOutputAudio->QueryInterface(IID_IMPEG2PIDMap, (void**)&m_pMp2DemuxAudioMap) != S_OK)
				throw CBonTsEngineException(L"I[fBIo̓sPID}bv̎擾Ɏs܂B\n");
		}
		

		// CMpeg2SequenceFilter
		{
			// CX^X쐬
			m_pMpeg2SeqFilter = CMpeg2SequenceFilter::CreateInstance(NULL, &hReturn,&m_pMpeg2SeqClass);
			if((!m_pMpeg2SeqFilter) || (hReturn != S_OK))
				throw CBonTsEngineException(L"Mpeg2V[PX擾tB^̍\zɎs܂B\n");
			m_pMpeg2SeqClass->SetRecvCallback(OnMpeg2VideoInfo,this);
			// tB^̒ǉƐڑ
			if(!CDirectShowUtil::AppendFilter_and_Connect(m_pMpeg2SeqFilter,
				L"Mpeg2SequenceFilter", m_pFilterGraph, &pOutputVideo))
				throw CBonTsEngineException(L"Mpeg2V[PX擾tB^̐ڑɎs܂B\n");
		}

		// CAacDecFilter
		{
			// CAacDecFilterCX^X쐬
			m_pAacDecFilter = CAacDecFilter::CreateInstance(NULL, &hReturn,&m_pAacDecClass);
			if((!m_pAacDecFilter) || (hReturn != S_OK))
				throw CBonTsEngineException(L"AACfR[_tB^̍\zɎs܂B\n");
			// tB^̒ǉƐڑ
			refCount = CDirectShowUtil::GetRefCount(m_pAacDecFilter);
			if(!CDirectShowUtil::AppendFilter_and_Connect(m_pAacDecFilter,
				L"AacDecFilter", m_pFilterGraph, &pOutputAudio))
				throw CBonTsEngineException(L"AACfR[_tB^̐ڑɎs܂B\n");
		}

		// CPcmSelectFilter
		{
			// CX^X쐬
			m_pPcmSelFilter = CPcmSelectFilter::CreateInstance(NULL, &hReturn,&m_pPcmSelClass);
			if((!m_pPcmSelFilter) || (hReturn != S_OK))
				throw CBonTsEngineException(L"PCMI[fBIItB^̍\zɎs܂B\n");
			// tB^̒ǉƐڑ
			if(!CDirectShowUtil::AppendFilter_and_Connect(m_pPcmSelFilter,
				L"PcmSelFilter", m_pFilterGraph, &pOutputAudio))
				throw CBonTsEngineException(L"PCMI[fBIItB^̐ڑɎs܂B\n");
		}

		// Mpeg2fR[_[
		{
			// 
			if(!cDSUtil.FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO))
				throw CBonTsEngineException(L"Mpeg2fR[_܂łB\n");
			// DfR[_[擪
			switch(m_eVideoDecoder)
			{
			case VideoDecoder_ATI:
				cDSUtil.PriorityFilterGoToHead(CLSID_ATI_MPEG_Video_Decoder);
				break;
			}
			// D揇ɐڑ݂
			if(!CDirectShowUtil::AppendMpeg2Decoder_and_Connect(m_pFilterGraph,&cDSUtil,&m_pMpeg2DecFilter,wszFilterName,128,&pOutputVideo))
				throw CBonTsEngineException(L"Mpeg2fR[_̐ڑɎs܂B\n");
			m_strMpeg2DecorderName = wszFilterName;
		}		
		
		// f_
		{
			if(eRendererType == CDirectShowUtil::Renderer_EVR){
				CDirectShowUtil::MF_Init();
				}
			if(eRendererType == CDirectShowUtil::Renderer_Default) {
				if(m_pFilterGraph->Render(pOutputVideo) != S_OK)
					throw CBonTsEngineException(L"ftHgrfI_̐ڑɎs܂B\n");
				m_eRendererType = eRendererType;
				} else {
				if(!CDirectShowUtil::CreateVideoRenderer(&m_pVideoRenderer,
						eRendererType, wszFilterName, 128)){
					throw CBonTsEngineException(L"rfI_(%d)̍\zɎs܂B\n",(int)eRendererType);
					}
				// Ô߃^Cv̍Ė⍇
				m_eRendererType = CDirectShowUtil::GetVideoRendererType(m_pVideoRenderer);
				// rfI_̐ݒ
				if(!SetupVideoRanderer(0,m_eRendererType,hOwnerHwnd,hMessageDrainHwnd))
					throw CBonTsEngineException(L"rfI_̐ݒɎs܂B\n>>%s",GetLastErrorString());
				if(!CDirectShowUtil::AppendFilter_and_Connect(m_pVideoRenderer, wszFilterName, m_pFilterGraph, &pOutputVideo))
					throw CBonTsEngineException(L"rfI_̐ڑɎs܂B\n%s\n",wszFilterName);
				}
			SAFE_RELEASE(pOutputVideo);
		}
		// _[\z
		{
			if(m_pFilterGraph->Render(pOutputAudio) != S_OK)
				throw CBonTsEngineException(L"ftHgI[fBI_̐ڑɎs܂B\n");
			SAFE_RELEASE(pOutputAudio);
		}
		// IBasicAudioC^[tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IBasicAudio, (void**)&m_pBasicAudio) != S_OK)
			throw CBonTsEngineException(L"IBasicAudioC^[tF[X̎擾Ɏs܂B\n");
		// rfI_̐ݒ
		if(!SetupVideoRanderer(1,m_eRendererType,hOwnerHwnd,hMessageDrainHwnd))
			throw CBonTsEngineException(L"rfI_̐ݒɎs܂B\n>>%s",GetLastErrorString());
		// I
		m_bInit=true;
		}
	catch(CBonTsEngineException & cErr){
		cErr.OutputDebugErrorMessage(L"OpenViewer : ");
		SetLastErrorString(cErr.GetErrorString());
		bRet = false;
		}
	if(bRet) {
		TRACE(TEXT("tB^Ot\z\n"));
		} else {
		CloseViewer();
		TRACE(TEXT("tB^Ot\zs\n"));
		}
	SAFE_RELEASE(pOutput);
	SAFE_RELEASE(pOutputVideo);
	SAFE_RELEASE(pOutputAudio);
	
	return bRet;
}

// rfI_̐ݒs
bool CMediaViewer::SetupVideoRanderer(int iPos,CDirectShowUtil::RendererType eRendererType,HWND hOwnerHwnd,HWND hMessageDrainHwnd)
{
	switch(eRendererType){
	case CDirectShowUtil::Renderer_Default:
		if(iPos==0) return true;
		return SetupVideoRanderer_Default(hOwnerHwnd,hMessageDrainHwnd);
		break;
	case CDirectShowUtil::Renderer_VMR7:
		if(iPos!=0) return true;
		return SetupVideoRanderer_VMR7(hOwnerHwnd);
		break;
	case CDirectShowUtil::Renderer_VMR9:
		if(iPos!=0) return true;
		return SetupVideoRanderer_VMR9(hOwnerHwnd);
		break;
	case CDirectShowUtil::Renderer_EVR:
		if(iPos!=0) return true;
		return SetupVideoRanderer_EVR(hOwnerHwnd);
		break;
		}
	return false;
}

// ftHg_̐ݒs
bool CMediaViewer::SetupVideoRanderer_Default(HWND hOwnerHwnd,HWND hMessageDrainHwnd)
{
	IVideoWindow *pVideoWindow = NULL;
	HRESULT hr;
	bool bRet = true;
	try {
		pVideoWindow = CDirectShowUtil::GetVideoWindow(m_pFilterGraph);
		if(!pVideoWindow) throw CBonTsEngineException(L"rfIEBhE̎擾ł܂B\n");
		// I[iEBhEݒ
		m_hOwnerWnd = hOwnerHwnd;	
		hr = pVideoWindow->put_Owner((OAHWND)hOwnerHwnd);
		if(FAILED(hr)) throw CBonTsEngineException(L"I[i[EBhE̐ݒ肪ł܂B\n");
		hr = pVideoWindow->put_MessageDrain((OAHWND)hMessageDrainHwnd);
		if(FAILED(hr)) throw CBonTsEngineException(L"bZ[WhCEBhE̐ݒ肪ł܂B\n");
		hr = pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);
		if(FAILED(hr)) throw CBonTsEngineException(L"X^C̐ݒ肪ł܂B\n");
		hr = pVideoWindow->put_BackgroundPalette(OATRUE);
		if(FAILED(hr)) throw CBonTsEngineException(L"pbg̓ݒ肪ł܂B\n");
		hr = pVideoWindow->put_BorderColor(RGB(0,0,0));
		if(FAILED(hr)) throw CBonTsEngineException(L"{[_[J[̐ݒ肪ł܂B\n");
		hr = pVideoWindow->put_Caption(L"");
		if(FAILED(hr)) throw CBonTsEngineException(L"LvVݒ肪ł܂B\n");
		
		RECT Rect;
		::GetClientRect(hOwnerHwnd, &Rect);
		pVideoWindow->SetWindowPosition(0, 0, Rect.right - Rect.left, Rect.bottom - Rect.top);
		pVideoWindow->SetWindowForeground(OATRUE);
		pVideoWindow->put_Visible(OATRUE);
		SetViewSize(Rect.right - Rect.left, Rect.bottom - Rect.top);
	} catch(CBonTsEngineException & cErr) {
		cErr.OutputDebugErrorMessage(L"DefaultRenderer : ");
		SetLastErrorString(cErr.GetErrorString());
		bRet = false;
	}
	SAFE_RELEASE(pVideoWindow);
	return bRet;
}

// VMR7̐ݒs
bool CMediaViewer::SetupVideoRanderer_VMR7(HWND hOwnerHwnd)
{
	IVMRFilterConfig *pFilterConfig = NULL;
	IVMRWindowlessControl *pWindowlessCtrl = NULL;
	HRESULT hr;
	bool bRet = true;
	try {
		// Windowless[hɂ
		hr = m_pVideoRenderer->QueryInterface(IID_IVMRFilterConfig,(void**)&pFilterConfig);
		if(FAILED(hr)) throw CBonTsEngineException(L"IVMRFilterConfig ̎擾ł܂B\n");
		hr = pFilterConfig->SetRenderingMode(VMRMode_Windowless);
		if(FAILED(hr)) throw CBonTsEngineException(L"WindowlessModeɐݒł܂B\n");
		// Windowless[h̐ݒs
		hr = m_pVideoRenderer->QueryInterface(IID_IVMRWindowlessControl,(void**)&pWindowlessCtrl);
		if(FAILED(hr)) throw CBonTsEngineException(L"IVMRWindowlessControl ̎擾ł܂B\n");
		hr = pWindowlessCtrl->SetVideoClippingWindow(hOwnerHwnd);
		if(FAILED(hr)) throw CBonTsEngineException(L"VideoClippingWindow̐ݒ肪ł܂B\n");
		hr = pWindowlessCtrl->SetAspectRatioMode(VMR9ARMode_None);
		if(FAILED(hr)) throw CBonTsEngineException(L"AXyNg䃂[h̐ݒ肪ł܂B\n");
		RECT Rect;
		::GetClientRect(hOwnerHwnd, &Rect);
		hr = pWindowlessCtrl->SetVideoPosition(NULL,&Rect);
		if(FAILED(hr)) throw CBonTsEngineException(L"rfI\ʒu̐ݒ肪ł܂B\n");
		hr = pWindowlessCtrl->SetBorderColor(RGB(0,0,0));
		if(FAILED(hr)) throw CBonTsEngineException(L"{[_[J[̐ݒ肪ł܂B\n");
	} catch(CBonTsEngineException & cErr) {
		cErr.OutputDebugErrorMessage(L"VMR7 : ");
		SetLastErrorString(cErr.GetErrorString());
		bRet = false;
	}
	SAFE_RELEASE(pFilterConfig);
	SAFE_RELEASE(pWindowlessCtrl);
	return bRet;
}

// VMR9̐ݒs
bool CMediaViewer::SetupVideoRanderer_VMR9(HWND hOwnerHwnd)
{
	IVMRFilterConfig9 *pFilterConfig = NULL;
	IVMRWindowlessControl9 *pWindowlessCtrl = NULL;
	HRESULT hr;
	bool bRet = true;
	try {
		// Windowless[hɂ
		hr = m_pVideoRenderer->QueryInterface(IID_IVMRFilterConfig9,(void**)&pFilterConfig);
		if(FAILED(hr)) throw CBonTsEngineException(L"IVMRFilterConfig9 ̎擾ł܂B\n");
		hr = pFilterConfig->SetRenderingMode(VMRMode_Windowless);
		if(FAILED(hr)) throw CBonTsEngineException(L"WindowlessModeɐݒł܂B\n");
		// Windowless[h̐ݒs
		hr = m_pVideoRenderer->QueryInterface(IID_IVMRWindowlessControl9,(void**)&pWindowlessCtrl);
		if(FAILED(hr)) throw CBonTsEngineException(L"IVMRWindowlessControl9 ̎擾ł܂B\n");
		hr = pWindowlessCtrl->SetVideoClippingWindow(hOwnerHwnd);
		if(FAILED(hr)) throw CBonTsEngineException(L"VideoClippingWindow̐ݒ肪ł܂B\n");
		hr = pWindowlessCtrl->SetAspectRatioMode(VMR9ARMode_None);
		if(FAILED(hr)) throw CBonTsEngineException(L"AXyNg䃂[h̐ݒ肪ł܂B\n");
		RECT Rect;
		::GetClientRect(hOwnerHwnd, &Rect);
		hr = pWindowlessCtrl->SetVideoPosition(NULL,&Rect);
		if(FAILED(hr)) throw CBonTsEngineException(L"rfI\ʒu̐ݒ肪ł܂B\n");
		hr = pWindowlessCtrl->SetBorderColor(RGB(0,0,0));
		if(FAILED(hr)) throw CBonTsEngineException(L"{[_[J[̐ݒ肪ł܂B\n");
	} catch(CBonTsEngineException & cErr) {
		cErr.OutputDebugErrorMessage(L"VMR9 : ");
		SetLastErrorString(cErr.GetErrorString());
		bRet = false;
	}
	SAFE_RELEASE(pFilterConfig);
	SAFE_RELEASE(pWindowlessCtrl);
	return bRet;
}

// EVR̐ݒs
bool CMediaViewer::SetupVideoRanderer_EVR(HWND hOwnerHwnd)
{
	IEVRFilterConfig *pFilterConfig = NULL;
	IMFVideoDisplayControl *pDispCtl = NULL;
	IMFVideoProcessor *pVProc = NULL;
	HRESULT hr;
	bool bRet = true;
	try {
		// Config
		pFilterConfig = CDirectShowUtil::MF_GetEVRFilterConfig(m_pVideoRenderer);
		if(!pFilterConfig) throw CBonTsEngineException(L"IEVRFilterConfig ̎擾ł܂B\n");
		hr = pFilterConfig->SetNumberOfStreams(1);
		if(FAILED(hr)) throw CBonTsEngineException(L"Xg[̐ݒł܂B\n");
		// Display̐ݒs
		pDispCtl = CDirectShowUtil::MF_GetVideoDisplayControl(m_pVideoRenderer);
		if(!pDispCtl) throw CBonTsEngineException(L"IMFVideoDisplayControl ̎擾ł܂B\n");
		hr = pDispCtl->SetVideoWindow(hOwnerHwnd);
		if(FAILED(hr)) throw CBonTsEngineException(L"VideoWindow̐ݒ肪ł܂B\n");
		hr = pDispCtl->SetAspectRatioMode(MFVideoARMode_None);
		if(FAILED(hr)) throw CBonTsEngineException(L"AXyNg䃂[h̐ݒ肪ł܂B\n");
		RECT Rect;
		::GetClientRect(hOwnerHwnd, &Rect);
		hr = pDispCtl->SetVideoPosition(NULL,&Rect);
		if(FAILED(hr)) throw CBonTsEngineException(L"rfI\ʒu̐ݒ肪ł܂B\n");
		hr = pDispCtl->SetBorderColor(RGB(0,0,0));		
		if(FAILED(hr)) throw CBonTsEngineException(L"{[_[J[̐ݒ肪ł܂B\n");		
		// rfIvZbTݒs
		pVProc = CDirectShowUtil::MF_GetVideoProcessor(m_pVideoRenderer);		
		if(!pVProc) throw CBonTsEngineException(L"rfIvZbT̎擾ł܂B\n");
		hr = pVProc->SetBackgroundColor(RGB(0,0,255));
		if(FAILED(hr)) throw CBonTsEngineException(L"wiF̐ݒ肪ł܂B\n");

	} catch(CBonTsEngineException & cErr) {
		cErr.OutputDebugErrorMessage(L"EVR : ");
		SetLastErrorString(cErr.GetErrorString());
		bRet = false;
	}
	SAFE_RELEASE(pFilterConfig);
	SAFE_RELEASE(pDispCtl);
	SAFE_RELEASE(pVProc)
	return bRet;
}

void CMediaViewer::CloseViewer(void)
{	
	// COMCX^XJ
	ULONG refCount=0;
	Stop();

	SAFE_RELEASE(m_pMp2DemuxVideoMap);
	SAFE_RELEASE(m_pMp2DemuxAudioMap);

	SAFE_RELEASE(m_pMp2DemuxRefClock);
	SAFE_RELEASE(m_pMp2DemuxInterface);
	SAFE_RELEASE(m_pMp2DemuxFilter);
	SAFE_RELEASE(m_pMpeg2DecFilter);

	SAFE_RELEASE(m_pMpeg2SeqFilter);
	SAFE_RELEASE(m_pAacDecFilter);		
	SAFE_RELEASE(m_pPcmSelFilter);

	SAFE_RELEASE(m_pVideoRenderer);

	SAFE_RELEASE(m_pBasicAudio);
	SAFE_RELEASE(m_pSrcFilter);	

	refCount = CDirectShowUtil::GetRefCount(m_pFilterGraph);
	SAFE_RELEASE(m_pFilterGraph);	

	if(m_dwRegister!=0){
		RemoveFromRot(m_dwRegister);
	}
	m_dwRegister = 0;
	// RefCount = 0 ɂȂĂȂ΂ǂŉRꂪ邩

	if(m_eRendererType == CDirectShowUtil::Renderer_EVR){
		CDirectShowUtil::MF_Term();
		}

	m_pBonSrcFilterClass = NULL;
	m_pMpeg2SeqClass = NULL;
	m_eRendererType = CDirectShowUtil::Renderer_Unknown;
	m_bInit = false;
}

const bool CMediaViewer::Play(void)
{
	// tB^OtĐ
	return CDirectShowUtil::FilterGrapph_Play(m_pFilterGraph);
}

const bool CMediaViewer::Stop(void)
{
	// tB^Ot~
	return CDirectShowUtil::FilterGrapph_Stop(m_pFilterGraph);
}

const bool CMediaViewer::SetVideoPID(const WORD wPID)
{
	// fo̓sPID}bsO
	if(!m_pMp2DemuxVideoMap)return false;

	if(wPID == m_wVideoEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wVideoEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wVideoEsPID;
		if(m_pMp2DemuxVideoMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxVideoMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wVideoEsPID = wPID;
	
	return true;
}

const bool CMediaViewer::SetAudioPID(const WORD wPID)
{
	// o̓sPID}bsO
	if(!m_pMp2DemuxAudioMap)return false;

	if(wPID == m_wAudioEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wAudioEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wAudioEsPID;
		if(m_pMp2DemuxAudioMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxAudioMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wAudioEsPID = wPID;
	
	return true;
}

void CMediaViewer::OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam)
{
	// rfI̍XV
	CMediaViewer *pThis=static_cast<CMediaViewer*>(pParam);
	if(memcmp(&pThis->m_VideoInfo,pVideoInfo,sizeof(Mpeg2VideoInfo))){
		// rfI̍XV
		pThis->m_VideoInfo = *pVideoInfo;
		pThis->ResizeVideoWindow();
		}
}

const bool CMediaViewer::ResizeVideoWindow()
{
	HRESULT hr;
	bool bRet = true;
	// EBhETCYύX
	int iAspectRatioX = m_VideoInfo.byAspectRatioX;
	int iAspectRatioY = m_VideoInfo.byAspectRatioY;
	if(m_VideoInfo.byAspectRatioX==0&&m_VideoInfo.byAspectRatioY==0){
		// rfIAXyNg䂪܂擾łĂȂꍇƂ16:9
		iAspectRatioX = 16;
		iAspectRatioY = 9;
		}
	if(m_iForceAspectRatioX!=0&&m_iForceAspectRatioY!=0)
	{
		iAspectRatioX = m_iForceAspectRatioX;
		iAspectRatioY = m_iForceAspectRatioY;
	}	
	WORD wX,wY;
	if(m_bFullscreen){			
		wX = (WORD)GetSystemMetrics(SM_CXSCREEN);
		wY = (WORD)GetSystemMetrics(SM_CYSCREEN);
		} else {
		wX = m_wVideoWindowX;
		wY = m_wVideoWindowY;
		}
	double vx , vy;
	if(iAspectRatioX>0 && iAspectRatioY>0){
		double aspect_rate = (double)iAspectRatioX / (double)iAspectRatioY;
		double window_rate = (double)wX / (double)wY;
		if(aspect_rate>window_rate){
			vx = wX;
			vy = vx * iAspectRatioY  / iAspectRatioX;
			} else {
			vy = wY;
			vx = vy * iAspectRatioX / iAspectRatioY;
			}
		} else {
		vx = wX;
		vy = wY;
		}

	POINT ptSrc   = {m_VideoInfo.wPosX,m_VideoInfo.wPosY};
	SIZE  sizeSrc = {m_VideoInfo.wWidth,m_VideoInfo.wHeight};
	POINT ptDest  = {(LONG)((wX-vx)/2),(LONG)((wY-vy)/2)};
	SIZE  sizeDest= {(LONG)vx,(LONG)vy};

	IVideoWindow *pVideoWindow = NULL;
	IBasicVideo2 *pBasicVideo = NULL;
	IVMRWindowlessControl *pWindowlessCtrl = NULL;
	IVMRWindowlessControl9 *pWindowlessCtrl9 = NULL;
	IMFVideoDisplayControl *pMFDispCtrl = NULL;
	try {
		switch(m_eRendererType)
		{
		case CDirectShowUtil::Renderer_Default:
			{
			//
			pVideoWindow = CDirectShowUtil::GetVideoWindow(m_pFilterGraph);
			if(!pVideoWindow) throw CBonTsEngineException(L"Can not query IVideoWindow.\n");
			pBasicVideo = CDirectShowUtil::GetBasicVideo2(m_pFilterGraph);
			if(!pBasicVideo) throw CBonTsEngineException(L"Can not query IBasicVideo2.\n");
			//
			hr = pBasicVideo->SetSourcePosition(ptSrc.x,ptSrc.y,sizeSrc.cx,sizeSrc.cy);
			if(FAILED(hr)) throw CBonTsEngineException(L"Error SetSourcePosition()\n");
			hr = pBasicVideo->SetDestinationPosition(ptDest.x,ptDest.y,sizeDest.cx,sizeDest.cy);
			if(FAILED(hr)) throw CBonTsEngineException(L"Error SetDestinationPosition()\n");
			hr = pVideoWindow->HideCursor(m_bFullscreen?OATRUE:OAFALSE);
			if(FAILED(hr)) throw CBonTsEngineException(L"Error HideCursor()\n");
			//
			hr = pVideoWindow->put_Left(0);
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. put_Left(%d)\n",0);
			hr = pVideoWindow->put_Width(wX);
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. put_Width(%d)\n",wX);
			hr = pVideoWindow->put_Top(0);
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. put_Top(%d)\n",0);
			hr = pVideoWindow->put_Height(wY);
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. put_Height(%d)\n",wY);
			}
			break;
		case CDirectShowUtil::Renderer_VMR7:
		case CDirectShowUtil::Renderer_VMR9:
		case CDirectShowUtil::Renderer_EVR:
		{
			//
			switch(m_eRendererType)
			{
			case CDirectShowUtil::Renderer_VMR7:
				hr = m_pVideoRenderer->QueryInterface(IID_IVMRWindowlessControl,(void**)&pWindowlessCtrl);
				if(FAILED(hr)) throw CBonTsEngineException(L"Can not query IVMRWindowlessControl.\n");
				break;
			case CDirectShowUtil::Renderer_VMR9:
				hr = m_pVideoRenderer->QueryInterface(IID_IVMRWindowlessControl9,(void**)&pWindowlessCtrl9);
				if(FAILED(hr)) throw CBonTsEngineException(L"Can not query IVMRWindowlessControl9.\n");
				break;
			case CDirectShowUtil::Renderer_EVR:
				pMFDispCtrl = CDirectShowUtil::MF_GetVideoDisplayControl(m_pVideoRenderer);
				if(!pMFDispCtrl) throw CBonTsEngineException(L"Can not query IMFVideoDisplayControl.\n");
				break;
			default:
				throw CBonTsEngineException(L"Can not query Interface.\n");
				break;
			}
			// \zɎw肵rfITCY̎擾
			LONG lNW,lNH;
			SIZE sizeNV,sizeNVAsp;
			switch(m_eRendererType)
			{
			case CDirectShowUtil::Renderer_VMR7:
				hr = pWindowlessCtrl->GetNativeVideoSize(&lNW,&lNH,NULL,NULL);
				break;
			case CDirectShowUtil::Renderer_VMR9:
				hr = pWindowlessCtrl9->GetNativeVideoSize(&lNW,&lNH,NULL,NULL);				
				break;
			case CDirectShowUtil::Renderer_EVR:			
				hr = pMFDispCtrl->GetNativeVideoSize(&sizeNV,&sizeNVAsp);
				lNW = sizeNV.cx;
				lNH = sizeNV.cy;
				break;
			default:
				hr = E_FAIL;
				break;
			}
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. GetNativeVideoSize()\n");
			// \[XrfITCY̎擾
			WORD wSW,wSH;
			if(!GetVideoSize(&wSW,&wSH))
				throw CBonTsEngineException(L"Failed. GetVideoSize()\n");
			// \zTCYɂ킹ē]TCYvZ
			RECT rcVmrSrc = {0,0,lNW,lNH};
			MFVideoNormalizedRect rcMFSrc = {0.0f,0.0f,1.0f,1.0f};			
			if(wSW>0 && wSH>0) {
				// VMR
				rcVmrSrc.left = ptSrc.x * lNW / wSW;
				rcVmrSrc.top  = ptSrc.y * lNH / wSH;
				rcVmrSrc.right = (sizeSrc.cx-ptSrc.x) * lNW / wSW;
				rcVmrSrc.bottom= (sizeSrc.cy-ptSrc.y) * lNH / wSH;
				// Media Foundation(0.0-1.0)
				rcMFSrc.left = (float)ptSrc.x / wSW;
				rcMFSrc.top  = (float)ptSrc.y / wSH;
				rcMFSrc.right = (float)(sizeSrc.cx-ptSrc.x) / wSW;
				rcMFSrc.bottom= (float)(sizeSrc.cy-ptSrc.y) / wSH;
			}
			RECT rcVmrDest = {ptDest.x,ptDest.y,ptDest.x+sizeDest.cx,ptDest.y+sizeDest.cy};
			switch(m_eRendererType)
			{
			case CDirectShowUtil::Renderer_VMR7:
				hr = pWindowlessCtrl->SetVideoPosition(&rcVmrSrc,&rcVmrDest);				
				break;
			case CDirectShowUtil::Renderer_VMR9:
				hr = pWindowlessCtrl9->SetVideoPosition(&rcVmrSrc,&rcVmrDest);
				break;
			case CDirectShowUtil::Renderer_EVR:				
				hr = pMFDispCtrl->SetVideoPosition(&rcMFSrc,&rcVmrDest);
				break;
			default:
				hr = E_FAIL;
				break;
			}
			if(FAILED(hr)) throw CBonTsEngineException(L"Failed. SetVideoPosition\n");
			// S~ĉŉʍXV(b)			
			::InvalidateRect(m_hOwnerWnd,NULL,TRUE);
			}
			break;
		}
	} catch(CBonTsEngineException & cErr) {
		cErr.OutputDebugErrorMessage(L"ResizeVideoWindow() : ");
		bRet = false;
	}
	SAFE_RELEASE(pVideoWindow);
	SAFE_RELEASE(pBasicVideo);
	SAFE_RELEASE(pWindowlessCtrl);
	SAFE_RELEASE(pWindowlessCtrl9);
	SAFE_RELEASE(pMFDispCtrl);
	return bRet;
}

const bool CMediaViewer::SetViewSize(const int x,const int y)
{
	// EBhETCYݒ肷
	if(x>0 && y>0){		
		m_wVideoWindowX = x;
		m_wVideoWindowY = y;
		return ResizeVideoWindow();
		}
	return false;
}

const bool CMediaViewer::SwitchFullscreen()
{
	/*
	// EBhE[hƃtXN[[h؂ւ(VMR/EVR͕s)
	// -> I[i[ł̎ɕύXAp~
	if(m_pVideoWindow){
		m_bFullscreen = !m_bFullscreen;
		m_pVideoWindow->put_Visible(OAFALSE);
		if(m_bFullscreen){
			m_pVideoWindow->put_Owner(NULL);			
			} else {
			m_pVideoWindow->put_Owner((OAHWND)m_hOwnerWnd);
			}
		m_pVideoWindow->put_Visible(OATRUE);
		ResizeVideoWindow();
		}		
	*/
	return true;
}

const bool CMediaViewer::SetVolume(const float fVolume)
{
	// I[fBI{[dBŐݒ肷( -100.0() < fVolume < 0(ő) )
	if(m_pBasicAudio){
		long lVolume = (long)(fVolume * 100);
		if(lVolume>=-10000&&lVolume<=0){
			TRACE(_T("Volume Control = %d\n"),lVolume);
			HRESULT hr = m_pBasicAudio->put_Volume(lVolume);
			if(SUCCEEDED(hr)){
				return true;
				}
			}
		}
	return false;
}

const bool CMediaViewer::GetVideoSize(WORD *pwWidth,WORD *pwHeight)
{
	// rfĨTCY擾
	if(m_pMpeg2SeqClass){
		return m_pMpeg2SeqClass->GetVideoSize(pwWidth,pwHeight);
		}
	return false;
}

const bool CMediaViewer::GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY)
{
	// rfĨAXyNg擾
	if(m_pMpeg2SeqClass){
		return m_pMpeg2SeqClass->GetAspectRatio(pbyAspectRatioX,pbyAspectRatioY);
		}
	return false;
}

const BYTE CMediaViewer::GetAudioChannelNum()
{
	// I[fBI̓̓`l擾
	if(m_pAacDecClass){
		return m_pAacDecClass->GetCurrentChannelNum();
		}
	return 0;
}

const bool CMediaViewer::SetStereoMode(const int iMode)
{
	// XeIo̓`l̐ݒ
	if(m_pPcmSelClass){
		m_pPcmSelClass->SetStereoMode(iMode);
		return true;
		}
	return false;
}

const bool CMediaViewer::GetVideoDecorderName(LPWSTR lpName,int iBufLen)
{
	// IĂrfIfR[_[̎擾
	if(m_pFilterGraph){
		lstrcpynW(lpName,m_strMpeg2DecorderName.GetBuffer(),iBufLen);
		return true;
		}
	return false;
}

const bool CMediaViewer::GetVideoRendererName(LPWSTR lpName,int iBufLen)
{
	// IĂrfI_̎擾
	if(m_pFilterGraph){
		switch(m_eRendererType){
		case CDirectShowUtil::Renderer_Default:
			lstrcpynW(lpName,L"Default",iBufLen);
			break;
		case CDirectShowUtil::Renderer_VMR7:
			lstrcpynW(lpName,L"VMR7",iBufLen);
			break;
		case CDirectShowUtil::Renderer_VMR9:
			lstrcpynW(lpName,L"VMR9",iBufLen);
			break;
		case CDirectShowUtil::Renderer_EVR:
			lstrcpynW(lpName,L"EVR",iBufLen);
			break;
		default:
			return false;
			}
		}
	return true;
}

const bool CMediaViewer::DisplayVideoDecorderProperty(HWND hWndParent)
{
	// rfIfR[_[̃vpeBJ
	return CDirectShowUtil::ShowPropertyPage(m_pMpeg2DecFilter,hWndParent);
}

const bool CMediaViewer::DisplayVideoRendererProperty(HWND hWndParent)
{
	// rfI_̃vpeBJ
	return CDirectShowUtil::ShowPropertyPage(m_pVideoRenderer,hWndParent);
}

HRESULT CMediaViewer::AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const
{
	// fobOp
	return CDirectShowUtil::AddToRot(pUnkGraph,pdwRegister);
}

void CMediaViewer::RemoveFromRot(const DWORD dwRegister) const
{
	// fobOp
	return CDirectShowUtil::RemoveFromRot(dwRegister);
}
