// MediaViewer.h: CMediaViewer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "TsException.h"
#include "MediaDecoder.h"
#include "TsUtilClass.h"
#include "BonSrcFilter.h"
#include "AacDecFilter.h"
#include "Mpeg2SequenceFilter.h"
#include "PcmSelectFilter.h"
#include <Bdaiface.h>
#include "DirectShowUtil.h"


/////////////////////////////////////////////////////////////////////////////
// fBAr[A(fyщĐ)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		̓f[^
/////////////////////////////////////////////////////////////////////////////

class CMediaViewer : public CMediaDecoder
	, public CBonTsEngineError
{
public:
	CMediaViewer(IEventHandler *pEventHandler = NULL);
	virtual ~CMediaViewer();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CMediaViewer
	const bool OpenViewer(HWND hOwnerHwnd = NULL,HWND hMessageDrainHwnd = NULL
		,CDirectShowUtil::RendererType eRendererType = CDirectShowUtil::Renderer_Default);
	void CloseViewer(void);

	const bool Play(void);
	const bool Stop(void);
	
	const bool SetVideoPID(const WORD wPID);
	const bool SetAudioPID(const WORD wPID);

	// Append by Meru
	const bool ResizeVideoWindow();
	const bool SetViewSize(const int x,const int y);
	const bool SwitchFullscreen();
	const bool SetVolume(const float fVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY);
	const BYTE GetAudioChannelNum();
	const bool SetStereoMode(const int iMode);
	const bool GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	const bool GetVideoRendererName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecorderProperty(HWND hWndParent);
	const bool DisplayVideoRendererProperty(HWND hWndParent);
	const bool SetForceAspectRatio(int iX=0,int iY=0)
	{
		m_iForceAspectRatioX = iX;
		m_iForceAspectRatioY = iY;
		ResizeVideoWindow();
		return true;
	}
	// DfR[_
	const enum PriorityVideoDecoder { VideoDecoder_Auto=0 , VideoDecoder_ATI };
	const bool SetPriorityVideoDecoder(enum PriorityVideoDecoder eDecoder=VideoDecoder_Auto )
	{
		switch(eDecoder)
		{
		case VideoDecoder_Auto:
		case VideoDecoder_ATI:
			m_eVideoDecoder = eDecoder;
			break;
		default:
			m_eVideoDecoder = VideoDecoder_Auto;
			return false;
		}
		return true;
	}

protected:
	CCriticalLock m_CriticalLock;

	// DirectShowC^tF[X
	bool m_bInit;
	
	// DirectShowtB^
	IGraphBuilder *m_pFilterGraph;
	IBaseFilter *m_pMp2DemuxFilter;
	IBaseFilter *m_pMpeg2DecFilter;
	// Source
	IBaseFilter *m_pSrcFilter;
	CBonSrcFilter *m_pBonSrcFilterClass;
	// Mpeg2-Sequence
	IBaseFilter *m_pMpeg2SeqFilter;
	CMpeg2SequenceFilter *m_pMpeg2SeqClass;
	// AAC
	IBaseFilter *m_pAacDecFilter;
	CAacDecFilter *m_pAacDecClass;
	// Pcm Select
	IBaseFilter *m_pPcmSelFilter;
	CPcmSelectFilter *m_pPcmSelClass;
	// Renderer
	IBaseFilter *m_pVideoRenderer;

	CStringW m_strMpeg2DecorderName;

	// MPEG2DemultiplexerC^tF[X
	IMpeg2Demultiplexer *m_pMp2DemuxInterface;
	IReferenceClock *m_pMp2DemuxRefClock;

	// rfIPID}bv
	IMPEG2PIDMap *m_pMp2DemuxVideoMap;
	IMPEG2PIDMap *m_pMp2DemuxAudioMap;

	// I[fBI
	IBasicAudio *m_pBasicAudio;
	
	// Elementary StreamPID
	WORD m_wVideoEsPID;
	WORD m_wAudioEsPID;

	bool SetupVideoRanderer(int iPos,CDirectShowUtil::RendererType eRendererType,HWND hOwnerHwnd,HWND hMessageDrainHwnd);
	bool SetupVideoRanderer_Default(HWND hOwnerHwnd,HWND hMessageDrainHwnd);
	bool SetupVideoRanderer_VMR7(HWND hOwnerHwnd);
	bool SetupVideoRanderer_VMR9(HWND hOwnerHwnd);
	bool SetupVideoRanderer_EVR(HWND hOwnerHwnd);
	static void CALLBACK OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam);
	WORD m_wVideoWindowX;
	WORD m_wVideoWindowY;
	Mpeg2VideoInfo m_VideoInfo;
	HWND m_hOwnerWnd;
	bool m_bFullscreen;

	int m_iForceAspectRatioX,m_iForceAspectRatioY;

	enum PriorityVideoDecoder m_eVideoDecoder;
	enum CDirectShowUtil::RendererType m_eRendererType;
	
private:
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const;
	void RemoveFromRot(const DWORD pdwRegister) const;

	DWORD m_dwRegister;
};
