#pragma once

#include "TransFrm.h"
#include "TsMedia.h"
#include "Mpeg2SequenceDec.h"

// ev[g
#define MPEG2SEQUENCEFILTER_NAME	(L"Mpeg2 Sequence Filter")

// ̃tB^GUID {3F8400DA-65F1-4694-BB05-303CDE739680}
DEFINE_GUID(CLSID_MPEG2SEQFILTER, 0x3f8400da, 0x65f1, 0x4694, 0xbb, 0x5, 0x30, 0x3c, 0xde, 0x73, 0x96, 0x80);

struct Mpeg2VideoInfo
{
	WORD wPosX,wPosY;
	WORD wWidth,wHeight;
	BYTE byAspectRatioX,byAspectRatioY;
};

class CMpeg2SequenceFilter : public CTransformFilter,
							 protected CMpeg2SequenceSplitter::ISequenceHandler
{

public:
	DECLARE_IUNKNOWN

	CMpeg2SequenceFilter(LPUNKNOWN pUnk, HRESULT *phr);
	~CMpeg2SequenceFilter(void);
	static IBaseFilter* WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *phr,CMpeg2SequenceFilter **ppClassIf);

// CTransformFilter
	HRESULT CheckInputType(const CMediaType* mtIn);
	HRESULT CheckTransform(const CMediaType* mtIn, const CMediaType* mtOut);
	HRESULT CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin);
	HRESULT DecideBufferSize(IMemAllocator * pAllocator, ALLOCATOR_PROPERTIES *pprop);
	HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT StartStreaming(void);
	HRESULT StopStreaming(void);

// CMpeg2SequenceFilter
	typedef void (CALLBACK MPEG2SEQUENCE_VIDEOINFO_FUNC)(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam);
	void SetRecvCallback(MPEG2SEQUENCE_VIDEOINFO_FUNC pCallback, const PVOID pParam = NULL);

	const bool GetVideoSize(WORD *pX, WORD *pY);
	const bool GetAspectRatio(BYTE *pX,BYTE *pY);

protected:
	HRESULT Transform(IMediaSample * pIn, IMediaSample *pOut);

// CMpeg2SequenceSplitter::ISequenceHandler
	virtual void OnSequence(const CMpeg2Sequence *pSequence);
	
// CMpeg2SequenceFilter
	MPEG2SEQUENCE_VIDEOINFO_FUNC *m_pfnVideoInfoRecvFunc;
	LPVOID m_pCallbackParam;

	CMpeg2Parser m_Mpeg2Parser;
	CMpeg2SequenceSplitter m_Mpeg2Sequence;

	Mpeg2VideoInfo m_VideoInfo;
};
